//
#include "F28x_Project.h"

//
// Globals
//
//Uint16 sdata[2];     // Send data buffer
//Uint16 rdata[2];     // Receive data buffer
//Uint16 rdata_point;  // Keep track of where we are
// in the data stream to check received data

//
// Function Prototypes
//
interrupt void SPIA_TX_ISR(void);
interrupt void SPIA_RX_ISR(void);
void delay_loop(void);
void spi_init(void);
void error();
void SPITX_INTERRUPT_Service();
void adc_enable();
void Sdata_command();
void Wreg_command1();
void Wreg_command2();
void Wreg_command3();
void Wreg_command4();
void Wreg_command5();
void Rreg_command1();
void Rreg_command2();
void Sync();
void main_loop();
void disable_fun();


//
// Main
//
int i, index, adc_flag,SPI_TX_RX,data;


void main(void)
{

//
// Step 1. Initialize System Control:
// PLL, WatchDog, enable Peripheral Clocks
// This example function is found in the F2837xD_SysCtrl.c file.
//
	InitSysCtrl();

//
// Step 2. Initialize GPIO:
// This example function is found in the F2837xD_Gpio.c file and
// illustrates how to set the GPIO to it's default state.
// Setup only the GP I/O only for SPI-A functionality
//
	InitGpio();
	GPIO_SetupPinMux(40, GPIO_MUX_CPU1, 0);                      //drdy
	GPIO_SetupPinOptions(40, GPIO_INPUT, GPIO_PUSHPULL);
	GPIO_SetupPinMux(42, GPIO_MUX_CPU1, 0);                      //reset
	GPIO_SetupPinOptions(42, GPIO_OUTPUT, GPIO_PUSHPULL);
	GPIO_SetupPinMux(48, GPIO_MUX_CPU1, 0);                      //start
	GPIO_SetupPinOptions(48, GPIO_OUTPUT, GPIO_PUSHPULL);
	InitSpiaGpio();
	GpioCtrlRegs.GPBMUX1.bit.GPIO40 = 0;
	GpioCtrlRegs.GPBGMUX1.bit.GPIO40 = 0;
	GpioCtrlRegs.GPBDIR.bit.GPIO40 = 0;

	GpioCtrlRegs.GPAMUX2.bit.GPIO19 = 0;
	GpioCtrlRegs.GPAGMUX2.bit.GPIO19 = 0;
	GpioCtrlRegs.GPADIR.bit.GPIO19 = 1;
	GpioDataRegs.GPACLEAR.bit.GPIO19 = 1;

// Step 3. Initialize PIE vector table:
// Disable and clear all CPU interrupts
//
	DINT;
	IER = 0x0000;
	IFR = 0x0000;

//
// Initialize PIE control registers to their default state:
// This function is found in the F2837xD_PieCtrl.c file.
//
	InitPieCtrl();

//
// Initialize the PIE vector table with pointers to the shell Interrupt
// Service Routines (ISR).
// This will populate the entire table, even if the interrupt
// is not used in this example.  This is useful for debug purposes.
// The shell ISR routines are found in F2837xD_DefaultIsr.c.
// This function is found in F2837xD_PieVect.c.
//
	InitPieVectTable();

//
// Interrupts that are used in this example are re-mapped to
// ISR functions found within this file.
//
	EALLOW;
	// This is needed to write to EALLOW protected registers
	PieVectTable.SPIA_RX_INT = &SPIA_RX_ISR;
	PieVectTable.SPIA_TX_INT = &SPIA_TX_ISR;
	EDIS;
	// This is needed to disable write to EALLOW protected registers

//
// Step 4. Initialize the Device Peripherals:
//
	spi_init();   // Initialize the SPI only
	for (i = 0; i < 32000; i++)
	{

	}

	GPIO_WritePin(42, 1);
	GPIO_WritePin(48, 1);

	/*for (i = 0; i < 32000; i++)
	{

	}*/
//		adc_flag=1;
//		index=1;
//		adc_enable();


	// Enable Global Interrupts

	//SPITX_INTERRUPT_Service();
//
// Step 5. User specific code, enable interrupts:
//

//
// Initialize the send data buffer
//
	/* for(i=0; i<2; i++)
	 {
	 sdata[i] = i;
	 }
	 rdata_point = 0;
	 */

//
// Enable interrupts required for this example
//
	PieCtrlRegs.PIECTRL.bit.ENPIE = 1;     // Enable the PIE block
	PieCtrlRegs.PIEIER6.bit.INTx1 = 1;     // Enable PIE Group 6, INT 1
	PieCtrlRegs.PIEIER6.bit.INTx2 = 1;     // Enable PIE Group 6, INT 2

	IFR = 0x00;
	IER = 0x20;    // Enable CPU INT6
	EINT;
	PieCtrlRegs.PIEACK.all = 0xFFFF;				//Clear all ACK bits before starting back ground loop.

	for (i = 0; i < 32000; i++);

	adc_flag=1;
	index=1;
	adc_enable();

//
// Step 6. IDLE loop. Just sit and loop forever (optional):
//
	for (;;);

}

//
// delay_loop - Function to provide delay
//
/*void delay_loop()
 {
 long i;
 for (i = 0; i < 1000000; i++) {}
 }*/

//
// error - Function to halt debugger on error
//
void error(void)
{
	asm("     ESTOP0");
	//Test failed!! Stop!
	for (;;);
}

//
// spi_fifo_init - Initialize SPI FIFO
//
void spi_init()
{
	 EALLOW;

		   SpiaRegs.SPICCR.bit.SPISWRESET = 0;     	// 7    SPI SW Reset
		   SpiaRegs.SPICCR.bit.SPICHAR = 0x7;	 	//      Character length of 8-bits.To facilate insturction code and data bytes of EEPROM.
		   SpiaRegs.SPICCR.bit.SPILBK     = 0;     	// 4    Loop-back is disable.
		   SpiaRegs.SPICCR.bit.CLKPOLARITY= 0;     	// 6    Data is shifted out on falling edge of clock.And recieved on
		   						        		    //       rising edge of clk to make compatibility with EEPROM.
		   SpiaRegs.SPIBRR.all = 0x0063;            //       Baud rate
		   SpiaRegs.SPICTL.bit.SPIINTENA    = 1;   // 0      Interrupts(SPIRXINT & SPITXINT)are enable.
		   SpiaRegs.SPICTL.bit.TALK         = 1;   // 1      Slave transmit is enable for EEPROM but must be
		   										   //        stop in case of DAC writting or donot read Rx for DAC.
		   SpiaRegs.SPICTL.bit.MASTER_SLAVE = 1;   // 2      SPI work as master.
		   SpiaRegs.SPICTL.bit.CLK_PHASE    = 1;   // 3      Output Data on clock.
		   SpiaRegs.SPICTL.bit.OVERRUNINTENA= 0;   // 4      Overrun interrupt is Disable as there is complete control on EEPROM. and no data from DAC.

		   SpiaRegs.SPIRXEMU	= 0x0000;		   // Dummy of SPIRXBUF clear to zero.
		   SpiaRegs.SPITXBUF	= 0x0000;		   // SPITXBUF clear to zero.
		   SpiaRegs.SPIRXBUF	= 0x0000;		   // SPIRXBUF clear to zero.
		   SpiaRegs.SPIDAT		= 0x0000;		   // clear initially to zero.
           SpiaRegs.SPIFFTX.bit.SPIFFENA   = 0;	//FIFo Feature is Disabled.
		   SpiaRegs.SPIPRI.bit.FREE    = 1;        // 4      Free emulation mode control is selected.
		   SpiaRegs.SPIPRI.bit.SOFT    = 1;        // 5      Soft emulation mode control is selected.
		   SpiaRegs.SPICCR.bit.SPISWRESET = 1;     // 7      SPI SW Out of reset.

		EDIS;


}

//
// spiTxFifoIsr - ISR for SPI transmit FIFO
//
interrupt void SPIA_TX_ISR(void)
{

	//SPITX_INTERRUPT_Service();
	PieCtrlRegs.PIEACK.bit.ACK6 = 1;
}

void SPITX_INTERRUPT_Service()
{

	if (index == 1 && adc_flag == 1)
	{
		adc_enable();
	}

	else if (index == 2)
	{
		Sdata_command();
	}

	else if (index == 3)
	{
		Wreg_command1();
	}

	else if (index == 4)
	{
		Wreg_command2();
	}

	else if (index == 5)
	{
		Wreg_command3();
	}

	else if (index == 6)
		{
			Wreg_command4();
		}


	else if (index == 7)
		{
			Wreg_command5();
		}

	else if (index == 8)
		{
			Rreg_command1();
		}

	else if (index == 9)
		{
			Rreg_command2();
		}

	else if (index == 10)
		{
			Sync();
		}

	else if (index == 11)
		{
			main_loop();
		}

	else if (index == 12)
		{
			disable_fun();
		}

	else
		{
			index = 1;
		}

}

void adc_enable()
{

	//adc_flag = 0;
	GPIO_WritePin(19, 0);     //cs
	asm(" NOP");
	asm(" NOP");
	SpiaRegs.SPIDAT = 0x06;
	SPI_TX_RX = 1;
	index = 2;

}

void Sdata_command()
{
	for (i = 0; i < 12000; i++);
	SpiaRegs.SPIDAT = 0x0016;
	index = 3;
}

void Wreg_command1()
{
	SpiaRegs.SPIDAT = 0x0040;
	index = 4;
}

void Wreg_command2()
{
	SpiaRegs.SPIDAT = 0x0003;
	index = 5;
}

void Wreg_command3()
{
	SpiaRegs.SPIDAT = 0x0001;
	index = 6;
}

void Wreg_command4()
{
	SpiaRegs.SPIDAT = 0x0003;
	index = 7;
}

void Wreg_command5()
{
	SpiaRegs.SPIDAT = 0x005F;
	index = 8;
}

void Rreg_command1()
{
	SpiaRegs.SPIDAT = 0x0020;
	index = 9;
}

void Rreg_command2()
{
	SpiaRegs.SPIDAT = 0x0003;
	index = 10;
}

void Sync()
{
	SpiaRegs.SPIDAT = 0x0004;

	for (i = 0; i < 34; i++);
	//GPIO_WritePin(19, 1);
	index = 11;

}

void main_loop()
{

	while(GpioDataRegs.GPBDAT.bit.GPIO40==0)
	{

    }

	//GPIO_WritePin(19, 0);

/*	while(GpioDataRegs.GPADAT.bit.GPIO19==0)
	{
		done1=1;
	}
*/

	asm(" NOP");
	asm(" NOP");
	SpiaRegs.SPIDAT = 0x0012;
	asm(" NOP");
	data = SpiaRegs.SPITXBUF;
	for (i = 0; i < 34; i++);

	index = 12;
}

void disable_fun(void)
{
	GPIO_WritePin(19, 0);
	asm(" NOP");
	asm(" NOP");
	SpiaRegs.SPIDAT = 0x0002;
	adc_flag = 0;
}

/*{
 Uint16 i;
 for(i=0;i<2;i++)
 {
 SpiaRegs.SPITXBUF=i;      // Send data
 }

 for(i=0;i<2;i++)                    // Increment data for next cycle
 {
 sdata = ;
 }

 SpiaRegs.SPIFFTX.bit.TXFFINTCLR=1;  // Clear Interrupt flag
 PieCtrlRegs.PIEACK.all|=0x20;       // Issue PIE ACK
 }*/


//
// spiRxFifoIsr - ISR for SPI receive FIFO
//
interrupt void SPIA_RX_ISR(void)
{



	 /*for(i=0; i<2; i++)
	 {
	 rdata[i]=SpiaRegs.SPIRXBUF;     // Read data
	 }

	 for(i=0; i<2; i++)                  // Check received data
	 {
	 if(rdata[i] != rdata_point+i)
	 {
	 error();
	 }
	 }*/

	 i = SpiaRegs.SPIRXBUF;     // Read data



   if (SPI_TX_RX == 0)
	{
		//	spib_rx_interupt_service();
	}
	else
	{
		SPITX_INTERRUPT_Service();
	}

	SpiaRegs.SPIFFRX.bit.RXFFOVFCLR = 1;  // Clear Overflow flag
	SpiaRegs.SPIFFRX.bit.RXFFINTCLR = 1;  // Clear Interrupt flag
	//PieCtrlRegs.PIEACK.all |= 0x20;       // Issue PIE ack
	PieCtrlRegs.PIEACK.bit.ACK6 = 1;

	//PieCtrlRegs.PIEACK.bit.ACK6 = 1;
	//SPITX_INTERRUPT_Service();
}

//
// End of file
//

